## chatterino-libcommuni 3.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(LibCommuni VERSION 3.7.0)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

option(BUILD_WITH_QT6 "Build with Qt6" On)

if (BUILD_WITH_QT6)
    set(MAJOR_QT_VERSION "6")
else()
    set(MAJOR_QT_VERSION "5")
endif()

find_package(Qt${MAJOR_QT_VERSION} REQUIRED COMPONENTS Core Network)

set(LibCommuni_INCLUDE_DIR "${CMAKE_CURRENT_LIST_DIR}/include/")
set(LibCommuni_SOURCE_DIR  "${CMAKE_CURRENT_LIST_DIR}/src/")

set(LibCommuni_definitions "IRC_STATIC IRC_NAMESPACE=Communi")

add_subdirectory(src/core)
add_subdirectory(src/model)
add_subdirectory(src/util)

add_library(LibCommuni)

target_link_libraries(LibCommuni Core Model Util)

add_library(LibCommuni::LibCommuni ALIAS LibCommuni)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    include(FeatureSummary)
    feature_summary(WHAT ALL)
endif ()

=== src/core/CMakeLists.txt ===
# ------------------------------------------------------------------------------------------------#
#  Core
# ------------------------------------------------------------------------------------------------#
include(GNUInstallDirs)

project(Core)

set(CONV_HEADERS
        ${LibCommuni_INCLUDE_DIR}/IrcCore/Irc
        ${LibCommuni_INCLUDE_DIR}/IrcCore/IrcCommand
        ${LibCommuni_INCLUDE_DIR}/IrcCore/IrcCommandFilter
        ${LibCommuni_INCLUDE_DIR}/IrcCore/IrcConnection
        ${LibCommuni_INCLUDE_DIR}/IrcCore/IrcCore
        ${LibCommuni_INCLUDE_DIR}/IrcCore/IrcGlobal
        ${LibCommuni_INCLUDE_DIR}/IrcCore/IrcMessage
        ${LibCommuni_INCLUDE_DIR}/IrcCore/IrcMessageFilter
        ${LibCommuni_INCLUDE_DIR}/IrcCore/IrcNetwork
        ${LibCommuni_INCLUDE_DIR}/IrcCore/IrcProtocol
        )

set(PUB_HEADERS
        ${LibCommuni_INCLUDE_DIR}/IrcCore/irc.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/irccommand.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircconnection.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/irccore.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircfilter.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircglobal.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircmessage.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircnetwork.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircprotocol.h
        )

set(PRIV_HEADERS
        ${LibCommuni_INCLUDE_DIR}/IrcCore/irccommand_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircconnection_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircdebug_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircmessage_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircmessagecomposer_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcCore/ircnetwork_p.h
        )

set(SOURCE_FILES
        ${CMAKE_CURRENT_LIST_DIR}/irc.cpp
        ${CMAKE_CURRENT_LIST_DIR}/irccommand.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircconnection.cpp
        ${CMAKE_CURRENT_LIST_DIR}/irccore.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircfilter.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircmessage.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircmessage_p.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircmessagecomposer.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircnetwork.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircprotocol.cpp
        #${LibCommuni_SOURCE_DIR}/3rdparty/mozilla/rdf_utils.c
        )

# Skip running moc for ircfilter.cpp as it does not need any moccing, but automoc finds a Q_OBJECT line in the comment in ircfilter.cpp
set_property(SOURCE ircfilter.cpp PROPERTY SKIP_AUTOMOC ON)
# We cannot skip running moc for irccommand.cpp because it has IRC_OBJECT defined in its header file and it needs moccing, however, there's a Q_OBJECT comment in the irccommand.cpp file which I've had to "break" to make this work
# set_property(SOURCE irccommand.cpp PROPERTY SKIP_AUTOMOC ON)

add_library(${PROJECT_NAME} STATIC ${PRIV_HEADERS} ${PUB_HEADERS} ${SOURCE_FILES})

target_link_libraries(${PROJECT_NAME} PUBLIC
    Qt${MAJOR_QT_VERSION}::Core
    Qt${MAJOR_QT_VERSION}::Network
    )
target_include_directories(${PROJECT_NAME} PUBLIC "${LibCommuni_INCLUDE_DIR}/IrcCore/")
target_compile_definitions(${PROJECT_NAME} PUBLIC IRC_STATIC IRC_NAMESPACE=Communi)

install(FILES ${PUB_HEADERS} ${CONV_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/IrcCore/)
install(TARGETS ${PROJECT_NAME} LIBRARY ARCHIVE)

=== src/model/CMakeLists.txt ===
# ------------------------------------------------------------------------------------------------#
#  Model
# ------------------------------------------------------------------------------------------------#

project(Model)


set(CONV_HEADERS
        ${LibCommuni_INCLUDE_DIR}/IrcModel/IrcBuffer
        ${LibCommuni_INCLUDE_DIR}/IrcModel/IrcBufferModel
        ${LibCommuni_INCLUDE_DIR}/IrcModel/IrcChannel
        ${LibCommuni_INCLUDE_DIR}/IrcModel/IrcModel
        ${LibCommuni_INCLUDE_DIR}/IrcModel/IrcUser
        ${LibCommuni_INCLUDE_DIR}/IrcModel/IrcUserModel
        )

set(PUB_HEADERS
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircbuffer.h
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircbuffermodel.h
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircchannel.h
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircmodel.h
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircuser.h
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircusermodel.h
        )

set(PRIV_HEADERS
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircbuffer_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircbuffermodel_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircchannel_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircuser_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcModel/ircusermodel_p.h
        )

set(SOURCE_FILES
        ${CMAKE_CURRENT_LIST_DIR}/ircbuffer.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircbuffermodel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircchannel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircmodel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircuser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircusermodel.cpp
        )

add_library(${PROJECT_NAME} STATIC ${PUB_HEADERS} ${PRIV_HEADERS} ${SOURCE_FILES})

target_link_libraries(${PROJECT_NAME} PUBLIC
    Qt${MAJOR_QT_VERSION}::Core
    Qt${MAJOR_QT_VERSION}::Network
    )
target_include_directories(${PROJECT_NAME} PUBLIC "${LibCommuni_INCLUDE_DIR}/IrcModel/" "${LibCommuni_INCLUDE_DIR}/IrcCore/")
target_compile_definitions(${PROJECT_NAME} PUBLIC IRC_STATIC IRC_NAMESPACE=Communi)

install(FILES ${PUB_HEADERS} ${CONV_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/IrcModel/)
install(TARGETS ${PROJECT_NAME} LIBRARY ARCHIVE)

=== src/util/CMakeLists.txt ===
# ------------------------------------------------------------------------------------------------#
#  Util
# ------------------------------------------------------------------------------------------------#

project(Util)

set(CONV_HEADERS
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/IrcCommandParser
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/IrcCommandQueue
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/IrcCompleter
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/IrcLagTimer
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/IrcPalette
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/IrcTextFormat
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/IrcUtil
        )

set(PUB_HEADERS
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/irccommandparser.h
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/irccommandqueue.h
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/irccompleter.h
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/irclagtimer.h
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/ircpalette.h
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/irctextformat.h
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/ircutil.h
        )

set(PRIV_HEADERS
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/irccommandparser_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/irccommandqueue_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/irclagtimer_p.h
        ${LibCommuni_INCLUDE_DIR}/IrcUtil/irctoken_p.h
        )

set(SOURCE_FILES
        ${CMAKE_CURRENT_LIST_DIR}/irccommandparser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/irccommandqueue.cpp
        ${CMAKE_CURRENT_LIST_DIR}/irccompleter.cpp
        ${CMAKE_CURRENT_LIST_DIR}/irclagtimer.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircpalette.cpp
        ${CMAKE_CURRENT_LIST_DIR}/irctextformat.cpp
        ${CMAKE_CURRENT_LIST_DIR}/irctoken.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ircutil.cpp
        )

add_library(${PROJECT_NAME} STATIC ${PUB_HEADERS} ${PRIV_HEADERS} ${SOURCE_FILES})

target_link_libraries(${PROJECT_NAME} PUBLIC
    Qt${MAJOR_QT_VERSION}::Core
    Qt${MAJOR_QT_VERSION}::Network
    )
target_include_directories(${PROJECT_NAME} PUBLIC "${LibCommuni_INCLUDE_DIR}/IrcUtil/" "${LibCommuni_INCLUDE_DIR}/IrcModel/" "${LibCommuni_INCLUDE_DIR}/IrcCore/")
target_compile_definitions(${PROJECT_NAME} PUBLIC IRC_STATIC IRC_NAMESPACE=Communi)

install(FILES ${PUB_HEADERS} ${CONV_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/IrcUtil/)
install(TARGETS ${PROJECT_NAME} LIBRARY ARCHIVE)

=== debian/changelog ===
chatterino-libcommuni (3.6.0-1) unstable; urgency=low

  * Initial release. (Closes: #1120852)

 -- CHow Yoong Jin <solomoncyj@gmail.com>  Mon, 17 Nov 2025 13:21:42 +0000

=== debian/control ===
Source: chatterino-libcommuni
Section: libs
Priority: optional
Maintainer: CHow Yoong Jin <solomoncyj@gmail.com>
Build-Depends:
 debhelper-compat (= 13), cmake, qt6-base-dev, 
Standards-Version: 4.7.0
Homepage: https://github.com/Chatterino/libcommuni
Rules-Requires-Root: no
#Vcs-Git: https://salsa.debian.org/debian/chatterino-libcommuni.git
#Vcs-Browser: https://salsa.debian.org/debian/chatterino-libcommuni

Package: chatterino-libcommuni-dev
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: libcommuni WIth Cmake
 A cross-platform IRC framework written with Qt.
 Communi provides a set of tools for enabling IRC connectivity in 
 Qt-based C++ and QML applications. See the online reference
 documentation for help with getting started.

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O1

%:
	dh $@ --buildsystem cmake
